From 337c06a3ed89cbe62647d823f8251f43215de610 Mon Sep 17 00:00:00 2001
From: Paul Marillonnet <pmarillonnet@entrouvert.com>
Date: Thu, 3 Feb 2022 18:07:42 +0100
Subject: [PATCH] add jura theme (#60724)

---
 static/jura/_custom.scss                      | 117 ++++++++++++++++++
 static/jura/_vars.scss                        |  67 ++++++++++
 static/jura/config.json                       |  16 +++
 static/jura/img/favicon.ico                   | Bin 0 -> 1150 bytes
 static/jura/img/motif.png                     | Bin 0 -> 2763 bytes
 static/jura/style.scss                        |   6 +
 .../variants/jura/combo/page_template.html    |  13 ++
 7 files changed, 219 insertions(+)
 create mode 100644 static/jura/_custom.scss
 create mode 100644 static/jura/_vars.scss
 create mode 100644 static/jura/config.json
 create mode 100644 static/jura/img/favicon.ico
 create mode 100644 static/jura/img/motif.png
 create mode 100644 static/jura/style.scss
 create mode 100644 templates/variants/jura/combo/page_template.html

diff --git a/static/jura/_custom.scss b/static/jura/_custom.scss
new file mode 100644
index 00000000..b626245a
--- /dev/null
+++ b/static/jura/_custom.scss
@@ -0,0 +1,117 @@
+//
+//	HEADER
+//
+
+h1#logo.has-logo a {
+	min-height: 70px;
+	@media screen and (max-width: $mobile-limit) {
+		margin-top: 20px;
+	}
+	@media (min-width: $mobile-limit + 1) {
+		min-height: 100px;
+		margin-top: 5px;
+	}
+}
+
+//
+//	NAV
+//
+
+div#nav {
+	@media screen and (max-width: $mobile-limit) {
+		padding-top: 20px;
+	}
+}
+
+//
+//	MAIN CONTENT
+//
+
+main {
+	background-image: linear-gradient(to right, #fff 0%, #f6f4f1 50%, #fff 100%);
+}
+
+.gru-content {
+	margin-top: 30px;
+	margin-bottom: 30px;
+}
+
+div.gru-content button,
+div.buttons .cancel-button button {
+	background-image: linear-gradient(to right, rgb(102, 160, 42) 0%, rgb(151, 192, 48) 45%, rgb(151, 192, 48) 100%);
+	box-shadow: unset;
+	&:hover {
+		background-position: center right, top right;
+		box-shadow: unset;
+	}
+}
+
+div.wcsformsofcategorycell {
+	picture img {
+		width: 100%;
+	}
+}
+
+.gru-content div.wcsformsofcategorycell.has-asset-picture > div picture img {
+	border-radius: $cell-border-radius;
+}
+
+#columns {
+	@media (min-width: $mobile-limit + 1) {
+		margin-left: 10%;
+		margin-right: 10%;
+	}
+}
+
+div#rub_service {
+	background: darken(#f6f4f1, 3%);
+}
+
+//
+//	FOOTER
+//
+
+#footer-wrapper {
+	margin-top: unset;
+	padding: 0 0 1.5em 0;
+	background: url('img/motif.png') top right repeat;
+}
+
+#footer {
+	h1, h2, h3 {
+		background: unset;
+	}
+	@media (min-width: $mobile-limit + 1) {
+		& > div {
+		padding-left: 3%;
+		padding-right: 3%;
+		}
+		& > div:first-child {
+			padding-left: 0;
+		}
+		& > div:last-child {
+			padding-right: 0;
+		}
+	}
+}
+
+.footer-logo {
+	@media (min-width: $mobile-limit + 1) {
+		margin-top: 1em;
+	}
+	img {
+		max-height: 15em;
+	}
+}
+
+.site-info {
+	@media (min-width: $mobile-limit + 1) {
+		margin-top: 3em;
+	}
+	min-width: 250px;
+}
+
+.herald-logo {
+	max-height: 17.45em;
+	min-width: 200px;
+}
diff --git a/static/jura/_vars.scss b/static/jura/_vars.scss
new file mode 100644
index 00000000..837d6f65
--- /dev/null
+++ b/static/jura/_vars.scss
@@ -0,0 +1,67 @@
+$primary-color: #97c030;
+$secondary-color: #514d46;
+
+$font-color: $secondary-color;
+$font-family: "PT Sans", Arial, sans-serif;
+$link-color: $primary-color;
+
+$notification_warning_color: #fbc261;
+$notification_success_color: $primary-color;
+$notification_info_color: $secondary-color;
+$notification_error_color: #ea656c;
+
+$border-radius: 10px;
+$mobile-limit: 1250px;
+$width: 80%;
+
+$nav-background: $secondary-color;
+$nav-submenu-background: $primary-color;
+$nav-submenu-color: white;
+$nav-color: white;
+$nav-active-color: $primary-color;
+$nav-item-selected-color: white;
+$nav-item-selected-background: $secondary-color;
+$nav-item-hover-color: white;
+$nav-item-hover-background: $secondary-color;
+
+$button-color: white;
+$button-background: rgb(151, 192, 48);
+$button-border-radius: 2px;
+$button-hover-background: $primary-color;
+
+$footer-background: #e6e6e6;
+$footer-color: black;
+$footer-link-color: black;
+$footer-menucell-separator: none;
+
+$sidebar-position: left;
+$sidebar-width: 265px;
+
+$title-background: transparent;
+$title-weight: bold;
+$title-transform: uppercase;
+$title-font-size: 30px;
+$title-color: $secondary-color;
+$title-border-radius: 20px;
+
+$widget-border: none;
+$widget-border-radius: 0px;
+$widget-background: white;
+$widget-focus-background: darken(white, 3%);
+
+$wcs-step-current-color: darken($primary-color, 10%);
+$wcs-step-current-background: white;
+$wcs-step-current-border: 2px solid #dd3333;
+$wcs-step_color: grey;
+$wcs-step-background: darken(#f6f4f1, 3%);
+$wcs-step-border-bottom: 2px solid grey;
+
+$cell-background: transparent;
+$cell-title-cover-border: false;
+$cell-entry-color: $font-color;
+$cell-entry-hover-color: #444444;
+$cell-entry-hover-background: #f8f8f8;
+$cell-border: none;
+$cell-border-radius: 13px;
+$cell-image-position: top;
+$cell-image-padding: none;
diff --git a/static/jura/config.json b/static/jura/config.json
new file mode 100644
index 00000000..6b246980
--- /dev/null
+++ b/static/jura/config.json
@@ -0,0 +1,16 @@
+{
+  "label": "Jura (CD39)",
+  "variables": {
+    "favicon": "jura/img/favicon.ico",
+    "theme_color": "#f6f4f1"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:logo": {"label": "Têtière : logo"},
+        "footer:logo": {"label": "Pied de page : logo"},
+        "footer:herald": {"label": "Pied de page : blason"}
+      }
+    }
+  }
+}
diff --git a/static/jura/img/favicon.ico b/static/jura/img/favicon.ico
new file mode 100644
index 0000000000000000000000000000000000000000..66ce373be221ec27fe2da696ed44da498e5bd390
GIT binary patch
diff --git a/static/jura/img/motif.png b/static/jura/img/motif.png
new file mode 100644
index 0000000000000000000000000000000000000000..3d36d411c75c4adb0f60b2fba2752843536fd6ea
GIT binary patch
diff --git a/static/jura/style.scss b/static/jura/style.scss
new file mode 100644
index 00000000..b4eedee8
--- /dev/null
+++ b/static/jura/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+
+@import '../includes/fonts/ptsans';
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
diff --git a/templates/variants/jura/combo/page_template.html b/templates/variants/jura/combo/page_template.html
new file mode 100644
index 00000000..514eb782
--- /dev/null
+++ b/templates/variants/jura/combo/page_template.html
@@ -0,0 +1,13 @@
+{% extends "combo/page_template.html" %}
+
+{% block footer-top %}
+ <div class="footer-logo grid-1-3">
+  <img src="{{site_base}}/assets/footer:logo" alt="Jura, le département">
+ </div>
+{% endblock %}
+
+{% block footer-bottom %}
+ <div class="herald-logo grid-1-3">
+  <img src="{{site_base}}/assets/footer:herald" alt="Décor blason">
+ </div>
+{% endblock %}}
-- 
2.34.1